package cn.iocoder.yudao.module.mes.service.deviceledger;

import java.util.*;
import javax.validation.*;

import cn.iocoder.yudao.module.erp.controller.admin.mold.vo.MoldRespVO;
import cn.iocoder.yudao.module.common.dal.dataobject.mold.MoldDO;
import cn.iocoder.yudao.module.erp.dal.dataobject.product.ErpProductDO;
import cn.iocoder.yudao.module.mes.controller.admin.deviceledger.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.deviceledger.DeviceLedgerDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;

import static cn.iocoder.yudao.framework.common.util.collection.CollectionUtils.convertMap;

/**
 * 设备类型 Service 接口
 *
 * @author 内蒙必硕
 */
public interface DeviceLedgerService {

    /**
     * 创建设备类型
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createDeviceLedger(@Valid DeviceLedgerSaveReqVO createReqVO);

    /**
     * 更新设备类型
     *
     * @param updateReqVO 更新信息
     */
    void updateDeviceLedger(@Valid DeviceLedgerSaveReqVO updateReqVO);

    /**
     * 删除设备类型
     *
     * @param id 编号
     */
    void deleteDeviceLedger( List<Long> idList );

    /**
     * 获得设备类型
     *
     * @param id 编号
     * @return 设备类型
     */
    DeviceLedgerDO getDeviceLedger(Long id);

    /**
     * 获得设备类型分页
     *
     * @param pageReqVO 分页查询
     * @return 设备类型分页
     */
    PageResult<DeviceLedgerDO> getDeviceLedgerPage(DeviceLedgerPageReqVO pageReqVO);

    List<DeviceLedgerDO> getDeviceLedgerList();
    /**
     * 获得产品 VO 列表
     *
     * @param ids 编号数组
     * @return 产品 VO 列表
     */
    List<DeviceLedgerRespVO> getDeviceLedgerVOList(Collection<Long> ids);
    /**
     * 获得设备 VO Map
     *
     * @param ids 编号数组
     * @return 模具 VO Map
     */
    default Map<Long, DeviceLedgerRespVO> getDeviceLedgerVOMap(Collection<Long> ids) {
        if(ids.isEmpty())return new HashMap<>();
        return convertMap(getDeviceLedgerVOList(ids), DeviceLedgerRespVO::getId);
    }


    List<ErpProductVO> exportSpareBased(Long id);

    List<MoldVO> exportMold(Long id);
}